import java.applet.Applet;
import java.awt.*;
import java.awt.event.*;

public class JavaDrie extends Applet implements AdjustmentListener, ActionListener
{
  private Scrollbar positieX,positieY, rood, groen, blauw;
  private Button start;
  private Color gold;

  //Deze methode tekent een wiel
  private void tekenWiel(Graphics pen, int x, int y)
  {
    //introduceer de benodigde lokale variabelen
    int breedte,hoogte;
    //teken de band
    breedte = 100;
    hoogte = 100;
    pen.setColor(Color.black);
    pen.fillOval(x, y, breedte, hoogte);
    //teken de velg
    breedte = 50;
    hoogte = 50;
    pen.setColor(Color.white);
    pen.fillOval(x+25, y+25, breedte, hoogte);
  }

  //Deze methode tekent een auto zonder wielen
  private void tekenAuto(Graphics pen, int x, int y)
  {
    //teken de body
    pen.fillRoundRect(x,y,300,100,50,50);
    //teken de voorruit
    pen.drawLine(x+75,y,x+125,y-100);
    pen.drawLine(x+125,y,x+125,y-100);
    //teken de achterruit
    pen.drawLine(x+225,y,x+225,y-100);
    pen.drawLine(x+275,y,x+225,y-100);
    //teken het dak
    pen.drawLine(x+125,y-100,x+225,y-100);
    //teken het voorwiel
    this.tekenWiel(pen,x+25,y+50);
    //teken het achterwiel
    this.tekenWiel(pen,x+175,y+50);
  }

  public void init()
  //init wordt automatisch aangeroepen bij het opstarten
  {
    //maak de schuifbalk aan
    rood      = new Scrollbar(Scrollbar.HORIZONTAL, 127, 1, 0, 256);
    groen     = new Scrollbar(Scrollbar.HORIZONTAL, 127, 1, 0, 256);
    blauw     = new Scrollbar(Scrollbar.HORIZONTAL, 127, 1, 0, 256);
    positieX  = new Scrollbar(Scrollbar.HORIZONTAL, 100, 1, 0, 201);
    positieY  = new Scrollbar(Scrollbar.HORIZONTAL, 250, 1, 150, 351);
    //maak de knop aan
    start = new Button("start");
    //voeg de schuifbalken en de knop toe aan this
    this.add(rood);
    this.add(groen);
    this.add(blauw);
    this.add(positieX);
    this.add(positieY);
    this.add(start);
    //zet de AdjustmentListener op de schuifbalken
    rood.addAdjustmentListener(this);
    groen.addAdjustmentListener(this);
    blauw.addAdjustmentListener(this);
    positieX.addAdjustmentListener(this);
    positieY.addAdjustmentListener(this);
    //zet de ActionListener op de knop
    start.addActionListener(this);
  }

  public void paint(Graphics pen)
  //paint wordt na init automatisch uitgevoerd
  {
    //introduceer de lokale variabelen
    int positieXWaarde, positieYWaarde, roodWaarde, groenWaarde, blauwWaarde;
    //verander de achtergrondkleur van de Applet in gold
    //en zet er een 3D kader omheen
    gold = new Color(255,215,0);
    pen.setColor(gold);
    pen.fill3DRect(0,0,500,500,true);
    pen.setColor(Color.black);
    //geef de componenten een aangepaste grootte
    rood.setSize(80,20);
    groen.setSize(80,20);
    blauw.setSize(80,20);
    positieX.setSize(80,20);
    positieY.setSize(80,20);
    start.setSize(30,20);
    //geef de componenten een aangepaste plaats
    rood.setLocation(5,10);
    groen.setLocation(95,10);
    blauw.setLocation(185,10);
    positieX.setLocation(275,10);
    positieY.setLocation(365,10);
    start.setLocation(455,10);
    //lees de waarden van de schuifbalken in
    roodWaarde       = rood.getValue();
    groenWaarde      = groen.getValue();
    blauwWaarde      = blauw.getValue();
    positieXWaarde  = positieX.getValue();
    positieYWaarde  = positieY.getValue();
    //zet de teksten bij de schuifbalken
    pen.drawString("Rood=" + roodWaarde, 20, 40);
    pen.drawString("Groen=" + groenWaarde, 110, 40);
    pen.drawString("Blauw=" + blauwWaarde, 200, 40);
    pen.drawString("X=" + positieXWaarde, 295,40);
    pen.drawString("Y=" + positieYWaarde, 385,40);
    //stel de kleur van de pen opnieuw in
    pen.setColor(new Color(roodWaarde, groenWaarde, blauwWaarde));
    //teken de auto
    this.tekenAuto(pen, positieXWaarde, positieYWaarde);
  }

  public void adjustmentValueChanged(AdjustmentEvent e)
  //deze methode wordt aangeroepen als n van de schuifbalken verschoven wordt
  {
    //teken de rechthoek opnieuw met de nieuwe kleuren
    repaint();
  }

  public void actionPerformed(ActionEvent e)
  //deze methode wordt aangeroepen als de knop start wordt ingedrukt
  {
    //zet alle kleuren weer op 0
    rood.setValue(127);
    groen.setValue(127);
    blauw.setValue(127);
    positieX.setValue(100);
    positieY.setValue(250);
    //teken de auto opnieuw met de nieuwe kleuren
    repaint();
    }
}
