import java.applet.Applet;
import java.awt.*;
import java.awt.event.*;

public class JavaVier extends Applet implements AdjustmentListener, ActionListener
{
  private Scrollbar aantalCirkelsBalk;
  private Button nulKnop,plusKnop;
  private TextField tekstVeld;
  private Color gold;
  private Image afbeelding;
  private Font lettertype;
  private int aantal,graden;
  private double hoek;
  private String sAantal;
  final double tweePI = 2 * Math.PI;
  final double halfPI = Math.PI / 2;

  //Deze methode tekent de cirkels
  private void tekenCirkels(Graphics pen, int aantal)
  {
    //introduceer de variabele i (teller)
    int i;
    //teken het aantal cirkels
    pen.setColor(Color.blue);
    for (i=1; i <= aantal; i++)
        pen.drawOval(50, 50, 20+2*i, 20+2*i);
  }

  public void init()
  //init wordt automatisch aangeroepen bij het opstarten
  {
    //definieer zelf de kleur gold (RGB)
    gold = new Color(255,215,0);
    //lees de afbeelding in, facultatief
    afbeelding = getImage(getDocumentBase(),"duke11.gif");
    //maak de schuifbalk aan, 201 waarden: 0 t/m 200
    aantalCirkelsBalk = new Scrollbar(Scrollbar.HORIZONTAL, 0, 1, 0, 201);
    //maak de knoppen aan
    nulKnop  = new Button("0");
    plusKnop = new Button("+20");
    //maak het tekstveld aan
    tekstVeld = new TextField();
    //voeg de schuifbalk, de knoppen en het tekstveld toe aan this
    this.add(aantalCirkelsBalk);
    this.add(nulKnop);
    this.add(plusKnop);
    this.add(tekstVeld);
    //zet de AdjustmentListener op de schuifbalk
    aantalCirkelsBalk.addAdjustmentListener(this);
    //zet de ActionListener op de knoppen
    nulKnop.addActionListener(this);
    plusKnop.addActionListener(this);
    //schakel de layout-manager uit
    setLayout(null);
    //geef de componenten een aangepaste grootte en plaats
    aantalCirkelsBalk.setBounds(10,10,400,15);
    nulKnop.setBounds(430,10,50,30);
    plusKnop.setBounds(430,50,50,30);
    tekstVeld.setBounds(435,470,50,20);
    //stel de achtergrondkleur van het tekstveld in
    tekstVeld.setBackground(Color.blue);
    //stel de voorgrondkleur van het tekstveld in
    tekstVeld.setForeground(Color.yellow);
    //stel de puntgroote van het lettertype in
    lettertype = new Font("Verdana",Font.BOLD,15);
    tekstVeld.setFont(lettertype);
    //schakel de edit mogelijkheid van het tekstveld uit
    tekstVeld.setEditable(false);
    //zet de uitlijning van het tekstveld op rechts
    //??
  }

  public void paint(Graphics pen)
  {
    int x,y;
    //paint wordt na init automatisch uitgevoerd
    //stel de kleur van de pen in op gold
    pen.setColor(gold);
    //verander de achtergrondkleur van de Applet in gold
    //en zet er een 3D kader omheen
    pen.fill3DRect(0,0,500,500,true);
    //stel de kleur van de pen weer in op zwart
    pen.setColor(Color.black);
    //lees de waarde van de schuifbalk in
    aantal  = aantalCirkelsBalk.getValue();
    //zet de tekst bij de schuifbalk
    pen.drawString("Aantal Cirkels: " + aantal, 10,40);
    //teken de cirkels
    this.tekenCirkels(pen, aantal);
    //geef de waarde van aantal weer in het tekstveld
    sAantal = Integer.toString(aantal/2);
    tekstVeld.setText(sAantal+"%");
    //teken een grafische voorstelling van het percentage
    //bij 0 graden gebeurt er niets
    graden = (int) (aantal * 1.8);
    pen.setColor(Color.red);
    pen.fillArc(415,385,80,80,90,graden);
    pen.setColor(Color.blue);
    pen.drawArc(415,385,80,80,90,graden);
    //teken het cirkeldiagram alleen als aantal != 0
    if (aantal > 0 && aantal < 200)
      {
        pen.drawLine(455,425,455,385);
        graden = graden + 90;
        hoek = halfPI - ((tweePI * graden) / 360);
        x= 455 + (int)( 40 * Math.sin(hoek));
        y= 425 + (int)(-40 * Math.cos(hoek));
        pen.drawLine(455, 425,x,y);
      }
    //plaats de afbeelding, facultatief
    pen.drawImage(afbeelding,00,185+aantal,315-aantal,315-aantal,this);
  }

  public void adjustmentValueChanged(AdjustmentEvent e)
  //deze methode wordt telkens aangeroepen, als de schuifbalk verschoven wordt
  {
    //teken de cirkels opnieuw
    repaint();
  }

  public void actionPerformed(ActionEvent e)
  //deze methode wordt aangeroepen als n van de knoppen wordt ingedrukt
  {
    //bepaal eerst welke knop ingedrukt werd
    Object object = e.getSource();
    //is het de nulKnop, roep dan de methode nulKnop_Action aan
	if (object == nulKnop)
	   nulKnop_Action(e);
    //of is het de plusKnop, roep dan de methode plusKnop_Action aan
	else if (object == plusKnop)
		plusKnop_Action(e);
    //teken de cirkels opnieuw
    repaint();
    }

    void nulKnop_Action(ActionEvent e)
    {
    //stel de waarde van de schuifbalk in op 0
    aantal = 0;
    aantalCirkelsBalk.setValue(aantal);
    }

    void plusKnop_Action(ActionEvent e)
    {
    //lees de actuele waarde van de schuifbalk in
    aantal  = aantalCirkelsBalk.getValue();
    //hoog de waarde met 20 op
    aantal = aantal + 20;
    //als de waarde > 200, haal er dan 200 van af
    if (aantal > 200)
    {
      aantal = aantal - 200;
    }
    //stel de waarde van de schuifbalk in op de nieuwe waarde
    aantalCirkelsBalk.setValue(aantal);
    }
}
